=== debian/changelog ===
opencv (4.6.0+dfsg-4ubuntu4) kinetic; urgency=medium

  * Build with GCC 11 to fix runtime crash.
    - debian/control: added gcc-11 and g++-11 to Build-Depends.
    - debian/rules: set CC and CXX in override_dh_auto_configure.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 23 Aug 2022 09:04:14 -0400

opencv (4.6.0+dfsg-4ubuntu3) kinetic; urgency=medium

  * No-change rebuild against libopenexr3-1-30

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 23 Aug 2022 04:03:46 +0000

opencv (4.6.0+dfsg-4ubuntu2) kinetic; urgency=medium

  * d/patches/ffmpeg5.patch: Remove references to deprecated
    ffmpeg constants.

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Fri, 05 Aug 2022 13:50:28 -0500

opencv (4.6.0+dfsg-4ubuntu1) kinetic; urgency=medium

  * Switch again to tbb2, needed for opencolorio

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 04 Aug 2022 17:13:39 +0200
